Index: pjproject/trunk/pjsip/src/pjsip-simple/xpidf.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-simple/xpidf.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsip-simple/xpidf.c	(revision 197)
@@ -17,8 +17,9 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <pjsip_simple/xpidf.h>
+#include <pjsip-simple/xpidf.h>
+#include <pj/assert.h>
+#include <pj/guid.h>
 #include <pj/pool.h>
 #include <pj/string.h>
-#include <pj/guid.h>
 
 static pj_str_t PRESENCE = { "presence", 8 };
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 197)
@@ -216,4 +216,7 @@
     /* Done. */
 
+    PJ_LOG(4,(THIS_FILE, "Module \"%.*s\" registered", 
+	      (int)mod->name.slen, mod->name.ptr));
+
 on_return:
     pj_rwmutex_unlock_write(endpt->mod_mutex);
@@ -254,4 +257,7 @@
     }
 
+    /* Module MUST NOT set module ID to -1. */
+    pj_assert(mod->id >= 0);
+
     /* Remove module from array. */
     endpt->modules[mod->id] = NULL;
@@ -265,4 +271,7 @@
     /* Done. */
     status = PJ_SUCCESS;
+
+    PJ_LOG(4,(THIS_FILE, "Module \"%.*s\" unregistered", 
+	      (int)mod->name.slen, mod->name.ptr));
 
 on_return:
Index: pjproject/trunk/pjsip/src/pjsip/sip_errno.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 197)
@@ -67,4 +67,5 @@
     /* Transaction errors */
     { PJSIP_ETSXDESTROYED,	"Transaction has been destroyed"},
+    { PJSIP_ENOTSX,		"No transaction (expecting stateful processing)" },
 
     /* Authentication. */
Index: pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 197)
@@ -146,5 +146,5 @@
     pj_strset2( &status_phrase[487], "Request Terminated");
     pj_strset2( &status_phrase[488], "Not Acceptable Here");
-    pj_strset2( &status_phrase[489], "Unknown Event");
+    pj_strset2( &status_phrase[489], "Bad Event");
     pj_strset2( &status_phrase[490], "Request Updated");
     pj_strset2( &status_phrase[491], "Request Pending");
Index: pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 197)
@@ -522,18 +522,30 @@
     }
 
-    /* Dialog MUST be found! */
+    /* Dialog may not be found, e.g. in this case:
+     *	- UAC sends SUBSCRIBE, then UAS sends NOTIFY before answering
+     *    SUBSCRIBE request with 2xx.
+     *
+     * In this case, we can accept the request ONLY when the original 
+     * dialog still has empty To tag.
+     */
     if (dlg == (pjsip_dialog*)&dlg_set->dlg_list) {
 
-	/* Not found. Mulfunction UAC? */
-	pj_mutex_unlock(mod_ua.mutex);
-
-	PJ_LOG(5,(THIS_FILE, 
-	          "Unable to find dialog for %s, answering with 481",
-		  pjsip_rx_data_get_info(rdata)));
-
-	pjsip_endpt_respond_stateless(mod_ua.endpt, rdata,
-				      PJSIP_SC_CALL_TSX_DOES_NOT_EXIST, 
-				      NULL, NULL, NULL);
-	return PJ_TRUE;
+	pjsip_dialog *first_dlg = dlg_set->dlg_list.next;
+
+	if (first_dlg->remote.info->tag.slen != 0) {
+	    /* Not found. Mulfunction UAC? */
+	    pj_mutex_unlock(mod_ua.mutex);
+
+	    PJ_LOG(5,(THIS_FILE, 
+		      "Unable to find dialog for %s, answering with 481",
+		      pjsip_rx_data_get_info(rdata)));
+
+	    pjsip_endpt_respond_stateless(mod_ua.endpt, rdata,
+					  PJSIP_SC_CALL_TSX_DOES_NOT_EXIST, 
+					  NULL, NULL, NULL);
+	    return PJ_TRUE;
+	}
+
+	dlg = first_dlg;
     }
 
Index: pjproject/trunk/pjsip/src/pjsua/main.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua/main.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsua/main.c	(revision 197)
@@ -23,5 +23,6 @@
 #define THIS_FILE	"main.c"
 
-static pjsip_inv_session *inv_session;
+/* Current dialog */
+static struct pjsua_inv_data *inv_session;
 
 /*
@@ -36,10 +37,14 @@
 
     if (inv->state == PJSIP_INV_STATE_DISCONNECTED) {
-	if (inv == inv_session)
-	    inv_session = NULL;
+	if (inv == inv_session->inv) {
+	    inv_session = inv_session->next;
+	    if (inv_session == &pjsua.inv_list)
+		inv_session = pjsua.inv_list.next;
+	}
 
     } else {
 
-	inv_session = inv;
+	if (inv_session == &pjsua.inv_list || inv_session == NULL)
+	    inv_session = inv->mod_data[pjsua.mod.id];
 
     }
@@ -57,22 +62,69 @@
 
 
+/*
+ * Print buddy list.
+ */
+static void print_buddy_list(void)
+{
+    unsigned i;
+
+    puts("Buddy list:");
+    //puts("-------------------------------------------------------------------------------");
+    if (pjsua.buddy_cnt == 0)
+	puts(" -none-");
+    else {
+	for (i=0; i<pjsua.buddy_cnt; ++i) {
+	    const char *status;
+
+	    if (pjsua.buddies[i].sub == NULL || 
+		pjsua.buddies[i].status.info_cnt==0)
+	    {
+		status = "   ?   ";
+	    } 
+	    else if (pjsua.buddies[i].status.info[0].basic_open)
+		status = " Online";
+	    else
+		status = "Offline";
+
+	    printf(" [%2d] <%s>  %s\n", 
+		    i+1, status, pjsua.buddies[i].uri.ptr);
+	}
+    }
+    puts("");
+}
 
 /*
  * Show a bit of help.
  */
-static void ui_help(void)
-{
-    puts("");
-    puts("Console keys:");
-    puts("  m    Make a call/another call");
-    puts("  d    Dump application states");
-    puts("  a    Answer incoming call");
-    puts("  h    Hangup current call");
-    puts("  q    Quit");
-    puts("");
+static void keystroke_help(void)
+{
+
+    printf(">>>>\nOnline status: %s\n", 
+	   (pjsua.online_status ? "Online" : "Invisible"));
+    print_buddy_list();
+    
+    //puts("Commands:");
+    puts("+=============================================================================+");
+    puts("|       Call Commands:         |      IM & Presence:      |   Misc:           |");
+    puts("|                              |                          |                   |");
+    puts("|  m  Make new call            |  i  Send IM              |  o  Send OPTIONS  |");
+    puts("|  a  Answer call              |  s  Subscribe presence   |  d  Dump status   |");
+    puts("|  h  Hangup call              |  u  Unsubscribe presence |  d1 Dump detailed |");
+    puts("|  ]  Select next dialog       |  t  Toggle Online status |                   |");
+    puts("|  [  Select previous dialog   |                          |                   |");
+    puts("+-----------------------------------------------------------------------------+");
+    puts("|  q  QUIT                                                                    |");
+    puts("+=============================================================================+");
+    printf(">>> ");
+
+
     fflush(stdout);
 }
 
-static pj_bool_t input(const char *title, char *buf, pj_size_t len)
+
+/*
+ * Input simple string
+ */
+static pj_bool_t simple_input(const char *title, char *buf, pj_size_t len)
 {
     char *p;
@@ -93,46 +145,129 @@
 }
 
+
+#define NO_NB	-2
+struct input_result
+{
+    int	  nb_result;
+    char *uri_result;
+};
+
+
+/*
+ * Input URL.
+ */
+static void ui_input_url(const char *title, char *buf, int len, 
+			 struct input_result *result)
+{
+    result->nb_result = NO_NB;
+    result->uri_result = NULL;
+
+    print_buddy_list();
+
+    printf("Choices:\n"
+	   "   0         For current dialog.\n"
+	   "  -1         All %d buddies in buddy list\n"
+	   "  [1 -%2d]    Select from buddy list\n"
+	   "  URL        An URL\n"
+	   "  <Enter>    Empty input (or 'q') to cancel\n"
+	   , pjsua.buddy_cnt, pjsua.buddy_cnt);
+    printf("%s: ", title);
+
+    fflush(stdout);
+    fgets(buf, len, stdin);
+    len = strlen(buf);
+
+    /* Left trim */
+    while (isspace(*buf)) {
+	++buf;
+	--len;
+    }
+
+    /* Remove trailing newlines */
+    while (len && (buf[len-1] == '\r' || buf[len-1] == '\n'))
+	buf[--len] = '\0';
+
+    if (len == 0 || buf[0]=='q')
+	return;
+
+    if (isdigit(*buf) || *buf=='-') {
+	
+	int i;
+	
+	if (*buf=='-')
+	    i = 1;
+	else
+	    i = 0;
+
+	for (; i<len; ++i) {
+	    if (!isdigit(buf[i])) {
+		puts("Invalid input");
+		return;
+	    }
+	}
+
+	result->nb_result = atoi(buf);
+
+	if (result->nb_result > 0 && result->nb_result <= (int)pjsua.buddy_cnt) {
+	    --result->nb_result;
+	    return;
+	}
+	if (result->nb_result == -1)
+	    return;
+
+	puts("Invalid input");
+	result->nb_result = NO_NB;
+	return;
+
+    } else {
+	pj_status_t status;
+
+	if ((status=pjsua_verify_sip_url(buf)) != PJ_SUCCESS) {
+	    pjsua_perror("Invalid URL", status);
+	    return;
+	}
+
+	result->uri_result = buf;
+    }
+}
+
 static void ui_console_main(void)
 {
+    char menuin[10];
     char buf[128];
     pjsip_inv_session *inv;
-
-    //ui_help();
+    struct input_result result;
+
+    //keystroke_help();
 
     for (;;) {
 
-	ui_help();
-	fgets(buf, sizeof(buf), stdin);
-
-	switch (buf[0]) {
+	keystroke_help();
+	fgets(menuin, sizeof(menuin), stdin);
+
+	switch (menuin[0]) {
 
 	case 'm':
-	    if (inv_session != NULL) {
-		puts("Can not make call while another one is in progress");
-		fflush(stdout);
-		continue;
-	    }
-
-#if 1
 	    /* Make call! : */
-	    if (!input("Enter URL to call", buf, sizeof(buf)))
-		continue;
-	    pjsua_invite(buf, &inv);
-
-#else
-
-	    pjsua_invite("sip:localhost:5061", &inv);
-#endif
-	    break;
-
-
-	case 'd':
-	    pjsua_dump();
-	    break;
+	    if (pj_list_size(&pjsua.inv_list))
+		printf("(You have %d calls)\n", pj_list_size(&pjsua.inv_list));
+	    
+	    ui_input_url("Make call", buf, sizeof(buf), &result);
+	    if (result.nb_result != NO_NB) {
+		if (result.nb_result == -1)
+		    puts("You can't do that with make call!");
+		else
+		    pjsua_invite(pjsua.buddies[result.nb_result].uri.ptr, &inv);
+	    } else if (result.uri_result)
+		pjsua_invite(result.uri_result, &inv);
+	    
+	    break;
+
 
 	case 'a':
 
-	    if (inv_session == NULL || inv_session->role != PJSIP_ROLE_UAS ||
-		inv_session->state >= PJSIP_INV_STATE_CONNECTING) 
+	    if (inv_session == &pjsua.inv_list || 
+		inv_session->inv->role != PJSIP_ROLE_UAS ||
+		inv_session->inv->state >= PJSIP_INV_STATE_CONNECTING) 
 	    {
 		puts("No pending incoming call");
@@ -144,5 +279,5 @@
 		pjsip_tx_data *tdata;
 
-		if (!input("Answer with code (100-699)", buf, sizeof(buf)))
+		if (!simple_input("Answer with code (100-699)", buf, sizeof(buf)))
 		    continue;
 		
@@ -150,8 +285,8 @@
 		    continue;
 
-		status = pjsip_inv_answer(inv_session, atoi(buf), NULL, NULL, 
-					  &tdata);
+		status = pjsip_inv_answer(inv_session->inv, atoi(buf), 
+					  NULL, NULL, &tdata);
 		if (status == PJ_SUCCESS)
-		    status = pjsip_inv_send_msg(inv_session, tdata, NULL);
+		    status = pjsip_inv_send_msg(inv_session->inv, tdata, NULL);
 
 		if (status != PJ_SUCCESS)
@@ -161,7 +296,8 @@
 	    break;
 
+
 	case 'h':
 
-	    if (inv_session == NULL) {
+	    if (inv_session == &pjsua.inv_list) {
 		puts("No current call");
 		fflush(stdout);
@@ -172,6 +308,6 @@
 		pjsip_tx_data *tdata;
 
-		status = pjsip_inv_end_session(inv_session, PJSIP_SC_DECLINE, 
-					       NULL, &tdata);
+		status = pjsip_inv_end_session(inv_session->inv, 
+					       PJSIP_SC_DECLINE, NULL, &tdata);
 		if (status != PJ_SUCCESS) {
 		    pjsua_perror("Failed to create end session message", status);
@@ -179,5 +315,5 @@
 		}
 
-		status = pjsip_inv_send_msg(inv_session, tdata, NULL);
+		status = pjsip_inv_send_msg(inv_session->inv, tdata, NULL);
 		if (status != PJ_SUCCESS) {
 		    pjsua_perror("Failed to send end session message", status);
@@ -185,5 +321,45 @@
 		}
 	    }
-
+	    break;
+
+	case ']':
+	    inv_session = inv_session->next;
+	    if (inv_session == &pjsua.inv_list)
+		inv_session = pjsua.inv_list.next;
+	    break;
+
+	case '[':
+	    inv_session = inv_session->prev;
+	    if (inv_session == &pjsua.inv_list)
+		inv_session = pjsua.inv_list.prev;
+	    break;
+
+	case 's':
+	case 'u':
+	    ui_input_url("Subscribe presence of", buf, sizeof(buf), &result);
+	    if (result.nb_result != NO_NB) {
+		if (result.nb_result == -1) {
+		    unsigned i;
+		    for (i=0; i<pjsua.buddy_cnt; ++i)
+			pjsua.buddies[i].monitor = (menuin[0]=='s');
+		} else {
+		    pjsua.buddies[result.nb_result].monitor = (menuin[0]=='s');
+		}
+
+		pjsua_pres_refresh();
+
+	    } else if (result.uri_result) {
+		puts("Sorry, can only subscribe to buddy's presence, not arbitrary URL (for now)");
+	    }
+
+	    break;
+
+	case 't':
+	    pjsua.online_status = !pjsua.online_status;
+	    pjsua_pres_refresh();
+	    break;
+
+	case 'd':
+	    pjsua_dump();
 	    break;
 
@@ -255,5 +431,5 @@
 {
     NULL, NULL,				/* prev, next.		*/
-    { "mod-console-msg-logger", 22 },	/* Name.		*/
+    { "mod-pjsua-log", 13 },		/* Name.		*/
     -1,					/* Id			*/
     PJSIP_MOD_PRIORITY_TRANSPORT_LAYER-1,/* Priority	        */
@@ -386,4 +562,9 @@
 
 
+    /* No current call initially: */
+
+    inv_session = &pjsua.inv_list;
+
+
     /* Start UI console main loop: */
 
Index: pjproject/trunk/pjsip/src/pjsua/pjsua.h
===================================================================
--- pjproject/trunk/pjsip/src/pjsua/pjsua.h	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsua/pjsua.h	(revision 197)
@@ -32,4 +32,7 @@
 #include <pjsip_ua.h>
 
+/* Include all PJSIP-SIMPLE headers */
+#include <pjsip_simple.h>
+
 /* Include all PJLIB-UTIL headers. */
 #include <pjlib-util.h>
@@ -60,4 +63,31 @@
     void		*mod_data[PJSIP_MAX_MODULE];
 };
+
+
+/**
+ * Buddy data.
+ */
+struct pjsua_buddy
+{
+    pj_str_t		 uri;	    /**< Buddy URI		        */
+    pj_bool_t		 monitor;   /**< Should we monitor?		*/
+    pjsip_evsub		*sub;	    /**< Buddy presence subscription	*/
+    pjsip_pres_status	 status;    /**< Buddy presence status.		*/
+};
+
+typedef struct pjsua_buddy pjsua_buddy;
+
+
+/**
+ * Server presence subscription list head.
+ */
+struct pjsua_srv_pres
+{
+    PJ_DECL_LIST_MEMBER(struct pjsua_srv_pres);
+    pjsip_evsub	    *sub;
+    char	    *remote;
+};
+
+typedef struct pjsua_srv_pres pjsua_srv_pres;
 
 
@@ -142,8 +172,11 @@
 
 
-    /* Buddy list: */
+    /* SIMPLE and buddy status: */
+
+    pj_bool_t	    online_status;  /**< Out online status.		*/
+    pjsua_srv_pres  pres_srv_list;  /**< Server subscription list.	*/
 
     unsigned	    buddy_cnt;
-    pj_str_t	    buddies[PJSUA_MAX_BUDDIES];
+    pjsua_buddy	    buddies[PJSUA_MAX_BUDDIES];
 };
 
@@ -236,4 +269,10 @@
 
 
+/**
+ * Terminate all calls.
+ */
+void pjsua_inv_shutdown(void);
+
+
 /*****************************************************************************
  * PJSUA Client Registration API (defined in pjsua_reg.c).
@@ -252,4 +291,31 @@
  */
 void pjsua_regc_update(pj_bool_t renew);
+
+
+
+
+/*****************************************************************************
+ * PJSUA Presence (pjsua_pres.c)
+ */
+
+/**
+ * Init presence.
+ */
+pj_status_t pjsua_pres_init();
+
+/**
+ * Refresh both presence client and server subscriptions.
+ */
+void pjsua_pres_refresh(void);
+
+/**
+ * Terminate all subscriptions
+ */
+void pjsua_pres_shutdown(void);
+
+/**
+ * Dump presence subscriptions.
+ */
+void pjsua_pres_dump(void);
 
 
Index: pjproject/trunk/pjsip/src/pjsua/pjsua_core.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua/pjsua_core.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsua/pjsua_core.c	(revision 197)
@@ -80,4 +80,9 @@
 
     pj_list_init(&pjsua.inv_list);
+
+    /* Init server presence subscription list: */
+    
+    pj_list_init(&pjsua.pres_srv_list);
+
 }
 
@@ -392,12 +397,12 @@
 
 
-static int PJ_THREAD_FUNC pjsua_worker_thread(void *arg)
+static int PJ_THREAD_FUNC pjsua_poll(void *arg)
 {
     PJ_UNUSED_ARG(arg);
 
-    while (!pjsua.quit_flag) {
+    do {
 	pj_time_val timeout = { 0, 10 };
 	pjsip_endpt_handle_events (pjsua.endpt, &timeout);
-    }
+    } while (!pjsua.quit_flag);
 
     return 0;
@@ -436,5 +441,5 @@
 
 
-    /* Init PJSIP and all the modules: */
+    /* Init PJSIP : */
 
     status = init_stack();
@@ -444,4 +449,18 @@
 	return status;
     }
+
+
+    /* Init core SIMPLE module : */
+
+    pjsip_evsub_init_module(pjsua.endpt);
+
+    /* Init presence module: */
+
+    pjsip_pres_init_module( pjsua.endpt, pjsip_evsub_instance());
+
+
+    /* Init pjsua presence handler: */
+
+    pjsua_pres_init();
 
 
@@ -610,5 +629,5 @@
 
     for (i=0; i<pjsua.thread_cnt; ++i) {
-	status = pj_thread_create( pjsua.pool, "pjsua", &pjsua_worker_thread,
+	status = pj_thread_create( pjsua.pool, "pjsua", &pjsua_poll,
 				   NULL, 0, 0, &pjsua.threads[i]);
 	if (status != PJ_SUCCESS) {
@@ -636,8 +655,23 @@
 
 
-
+    PJ_LOG(3,(THIS_FILE, "PJSUA version %s started", PJ_VERSION));
     return PJ_SUCCESS;
 }
 
+
+/* Sleep with polling */
+static void busy_sleep(unsigned msec)
+{
+    pj_time_val timeout, now;
+
+    pj_gettimeofday(&timeout);
+    timeout.msec += msec;
+    pj_time_val_normalize(&timeout);
+
+    do {
+	pjsua_poll(NULL);
+	pj_gettimeofday(&now);
+    } while (PJ_TIME_VAL_LT(now, timeout));
+}
 
 /*
@@ -648,31 +682,8 @@
     int i;
 
-    /* Unregister, if required: */
-    if (pjsua.regc) {
-
-	pjsua_regc_update(0);
-
-	/* Wait for some time to allow unregistration to complete: */
-
-	pj_thread_sleep(500);
-    }
-
     /* Signal threads to quit: */
-
     pjsua.quit_flag = 1;
 
-
-    /* Shutdown pjmedia-codec: */
-
-    pjmedia_codec_deinit();
-
-
-    /* Destroy sound framework: 
-     * (this should be done in pjmedia_shutdown())
-     */
-    pj_snd_deinit();
-
     /* Wait worker threads to quit: */
-
     for (i=0; i<pjsua.thread_cnt; ++i) {
 	
@@ -684,4 +695,28 @@
     }
 
+
+    /* Terminate all calls. */
+    pjsua_inv_shutdown();
+
+    /* Terminate all presence subscriptions. */
+    pjsua_pres_shutdown();
+
+    /* Unregister, if required: */
+    if (pjsua.regc) {
+	pjsua_regc_update(0);
+    }
+
+    /* Wait for some time to allow unregistration to complete: */
+    PJ_LOG(4,(THIS_FILE, "Shutting down..."));
+    busy_sleep(1000);
+
+    /* Shutdown pjmedia-codec: */
+    pjmedia_codec_deinit();
+
+    /* Destroy sound framework: 
+     * (this should be done in pjmedia_shutdown())
+     */
+    pj_snd_deinit();
+
     /* Destroy endpoint. */
 
Index: pjproject/trunk/pjsip/src/pjsua/pjsua_inv.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua/pjsua_inv.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsua/pjsua_inv.c	(revision 197)
@@ -81,4 +81,5 @@
     inv_data->inv = inv;
     dlg->mod_data[pjsua.mod.id] = inv_data;
+    inv->mod_data[pjsua.mod.id] = inv_data;
 
 
@@ -222,4 +223,5 @@
 	    inv_data->inv = inv;
 	    dlg->mod_data[pjsua.mod.id] = inv_data;
+	    inv->mod_data[pjsua.mod.id] = inv_data;
 
 	    pj_list_push_back(&pjsua.inv_list, inv_data);
@@ -346,2 +348,24 @@
     }
 }
+
+
+/*
+ * Terminate all calls.
+ */
+void pjsua_inv_shutdown()
+{
+    struct pjsua_inv_data *inv_data, *next;
+
+    inv_data = pjsua.inv_list.next;
+    while (inv_data != &pjsua.inv_list) {
+	pjsip_tx_data *tdata;
+
+	next = inv_data->next;
+
+	if (pjsip_inv_end_session(inv_data->inv, 410, NULL, &tdata)==0)
+	    pjsip_inv_send_msg(inv_data->inv, tdata, NULL);
+
+	inv_data = next;
+    }
+}
+
Index: pjproject/trunk/pjsip/src/pjsua/pjsua_opt.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua/pjsua_opt.c	(revision 196)
+++ pjproject/trunk/pjsip/src/pjsua/pjsua_opt.c	(revision 197)
@@ -404,5 +404,5 @@
 		return -1;
 	    }
-	    pjsua.buddies[pjsua.buddy_cnt++] = pj_str(optarg);
+	    pjsua.buddies[pjsua.buddy_cnt++].uri = pj_str(optarg);
 	    break;
 	}
@@ -511,4 +511,5 @@
     pjsip_endpt_dump(pjsua.endpt, 1);
     pjmedia_endpt_dump(pjsua.med_endpt);
+    pjsip_tsx_layer_dump();
     pjsip_ua_dump();
 
@@ -536,4 +537,7 @@
 	}
     }
+
+    /* Dump presence status */
+    pjsua_pres_dump();
 
     pj_log_set_decor(old_decor);
@@ -548,6 +552,7 @@
 {
     int argc = 3;
-    char *argv[] = { "pjsua", "--config-file", (char*)filename, NULL};
-
+    char *argv[4] = { "pjsua", "--config-file", NULL, NULL};
+
+    argv[3] = (char*)filename;
     return pjsua_parse_args(argc, argv);
 }
@@ -655,6 +660,6 @@
     for (i=0; i<pjsua.buddy_cnt; ++i) {
 	pj_ansi_sprintf(line, "--add-buddy %.*s\n",
-			      (int)pjsua.buddies[i].slen,
-			      pjsua.buddies[i].ptr);
+			      (int)pjsua.buddies[i].uri.slen,
+			      pjsua.buddies[i].uri.ptr);
 	pj_strcat2(&cfg, line);
     }
